import os, sys, math, random, time, pygame
from pygame.locals import *
from pygame.compat import geterror

import const, util, image, var

class Explosion(pygame.sprite.DirtySprite):
    def __init__(self, rect, is_paddle, big):
        pygame.sprite.DirtySprite.__init__(self)
        if big:
            self.images = image.images.explosion_big    #dynamite brick explosion
        else:
            self.images = image.images.explosion_small
        self.image = self.images[0]
        self.rect = self.image.get_rect()
        self.rect[0] = rect[0] + rect[2]/2 - self.rect[2]/2
        self.rect[1] = rect[1] + rect[3]/2 - self.rect[3]/2
        self.frame = 0
        self.max_frames = len(self.images)
        self.delay = 0
        self.is_paddle = is_paddle      #if it's paddle that explodes, lose life when explosion is over
        var.game.allsprites.add(self, layer=3)
        
    def update(self):
        self.delay += 1
        if self.delay % 2:
            self.dirty = 1
            self.frame += 1
            if self.frame >= self.max_frames:
                self.stop()
            else:
                self.image = self.images[self.frame]    

    def stop(self):
        var.game.allsprites.remove(self)
        if self.is_paddle and var.game.bonusdata["strong"]["cnt"] == 0:
            var.game.lose_life()            

        
