#!/usr/bin/perl 
#
# make a colored dial for bonus (to display time left till it's finished)
# requires ImageMagick command line utilities: convert and montage
#
# (I gave up and wrote it in Perl because it's not part of the game, and writing in Perl is much easier for me ;)

$color = shift(@ARGV);
die "Please specify color!" unless defined $color;

$pi = 3.1415926;
$r = 8;    #if you change the radius, change also in interface.py
$d = $r*2;
$size = ($d+1).'x'.($d+1);
$color1 = "#909090";
$x00 = $r;
$y00 = $r;
$x0 = $r;
$y0 = 0;

$n = 0;
$base = "dial_".$color;
$filename = $base.'_'.sprintf("%03d",$n++).".png"; #empty
$command = "convert -size $size canvas:none -stroke \"$color\" -fill \"$color1\" -draw \"circle $x00,$y00 $x0,$y0\" ".$filename;
print "$command\n";
system($command);

$filename = $base.'_'.sprintf("%03d",$n++).".png"; #full
$command = "convert -size $size canvas:none -stroke \"$color\" -fill \"$color\" -draw \"circle $x00,$y00 $x0,$y0\" ".$filename;
print "$command\n";
system($command);

for ($p = 1; $p < 100; $p+=2) {
  $a0 = $p * 360 / 100;
  $filename = $base.'_'.sprintf("%03d",$n++).".png";
  $a = $pi * $a0 / 180;
  $x1 = $x0 + $r * sin($a);
  $y1 = $y0 + $r * (1 - cos($a));
  $mode = ($a0>180)?1:0;  #I don't know where this comes from, found by experiment

  $command = "convert -size $size canvas:none -stroke \"$color\" -fill \"$color\" -draw \"circle $x00,$y00 $x0,$y0\" -fill \"$color1\" -draw \"path 'M $x00,$y00  L $x0,$y0  A $r,$r 0 $mode,1 $x1,$y1 Z'\" ".$filename;
  print "$command\n";
  system($command);
}

$command = "montage -tile $n"."x1 -background none -geometry +2+0 $base"."*.png tmp.png";
print "$command\n";
system($command);
rename("tmp.png","$base.png");




